// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import Vue from 'vue'
import App from './App'
import router from './router'
import ElementUI from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'
import KRtcClient  from  '../static/sdk/main'
import ElementResizeDetectorMaker from "element-resize-detector"

const KRtcClientId = KRtcClient.getClientIds();
let kRtcClient = null;
if(KRtcClientId.length>0){
  console.log("初始化")
  kRtcClient = new KRtcClient({clientId: KRtcClientId[0]});
}
else{
  console.log("无实例初始化")
  kRtcClient = new KRtcClient();
}
console.log("kRtcClient",kRtcClient)
window.sdk = kRtcClient

router.beforeEach((to, from, next) => {
  const isLogin = JSON.parse(window.atob(JSON.parse(localStorage.getItem(kRtcClient._singleSdk.getClientId()))["kAuthorization"]))["ssoToken"] || null
  console.log("isLogin",isLogin)
  if(!isLogin && to.path !== '/login'){
    kRtcClient.init(
      {
        hostname: window.location.host,
        autoSubAllVideoStream:true,
        autoPubLocalStream:true,
        protocol: process.env.NODE_ENV === 'development' ? 'http' : 'https',
        isKrtcLogin:true,
        success:()=>{
          console.log("初始化成功")
          const isLoginNext = JSON.parse(window.atob(JSON.parse(localStorage.getItem(kRtcClient._singleSdk.getClientId()))["kAuthorization"]))["ssoToken"] || null
          if(isLoginNext){
            next()
          }else{
            next({path:'/login'})
          }
        },
        error:(errorMoadl)=>{
          console.log("初始化失败",errorMoadl)
          next({path:'/login'})
        }
      }
    )
  }else if(to.path == '/login' && isLogin){
    console.log("退出登录")
    kRtcClient.exit()
    // KRtcClient.destroy()
    // kRtcClient = new KRtcClient();
    next()
  }else{
    next()
  }
})
Vue.config.devtools = true;
Vue.prototype.$KRtcClient = kRtcClient;
Vue.config.productionTip = false
Vue.prototype.$erd = ElementResizeDetectorMaker();
Vue.use(ElementUI)

/* eslint-disable no-new */
new Vue({
  el: '#app',
  router,
  components: { App },
  template: '<App/>'
})
